diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/daemon/driver/driverInteractive.ml ./src/daemon/driver/driverInteractive.ml
--- ./src/daemon/driver/driverInteractive.ml	2006-09-07 12:55:11.000000000 +0200
+++ ./src/daemon/driver/driverInteractive.ml	2006-09-19 19:03:10.000000000 +0200
@@ -49,19 +49,10 @@
   lprintf2 log_prefix fmt
 
 let verify_user_admin () =
-  let empty_pwd = ref false in
-  begin try
-    if user2_password admin_user = blank_password then
-      empty_pwd := true
-    with e ->
-      lprintf_nl (_b "SECURITY INFO: user 'admin' has to be present, creating...");
-      empty_pwd := true;
-      ignore (user2_add admin_user blank_password "")
-  end;
   let warning =
     "SECURITY WARNING: user admin has an empty password, use command: useradd admin password\n"
   in
-  if !empty_pwd && not !!enable_user_config then
+  if empty_password admin_user then
     begin
       lprintf_n "%s" warning;
       warning
@@ -1867,7 +1858,8 @@
   tack list 
     (
       "Features:\t",
-      (if BasicSocket.has_threads () then "threads" else "no-threads") ^
+      ("multiuser") ^
+      (if BasicSocket.has_threads () then " threads" else " no-threads") ^
       (let s = Zlib.zlib_version_num () in 
          Printf.sprintf " zlib%s" (if s <> "" then "-" ^ s else "")) ^
       (if Autoconf.bzip2 then
@@ -2186,11 +2178,11 @@
   if html then Printf.bprintf buf "\\</tr\\>\\</table\\>\\</div\\>\\</div\\>";
   Buffer.contents buf
 
-let dllink_query_networks html url =
+let dllink_query_networks html url user =
   let result = ref [] in
   if not (networks_iter_until_true (fun n ->
     try
-      let s,r = network_parse_url n url in
+      let s,r = network_parse_url n url user in
         if s = "" then
           r
         else
@@ -2208,7 +2200,7 @@
   else
     dllink_print_result html url "Added link" !result
 
-let dllink_parse html url =
+let dllink_parse html url user =
   if (String2.starts_with url "http") then (
     let u = Url.of_string url in
     let module H = Http_client in
@@ -2242,21 +2234,14 @@
       let concat_headers =
         (List.fold_right (fun (n, c) t -> n ^ ": " ^ c ^ "\n" ^ t) headers "")
       in
-      ignore (dllink_query_networks html concat_headers)
+      ignore (dllink_query_networks html concat_headers user)
     );
     dllink_print_result html url "Parsing HTTP url" [])
   else
     if (String2.starts_with url "ftp") then
-      dllink_query_networks html (Printf.sprintf "Location: %s" url)
+      dllink_query_networks html (Printf.sprintf "Location: %s" url) user
     else
-      dllink_query_networks html url
-
-let print_command_result o buf result =
-  if use_html_mods o then
-    html_mods_table_one_row buf "serversTable" "servers" [
-      ("", "srh", result); ]
-  else
-    Printf.bprintf buf "%s" result
+      dllink_query_networks html url user
 
 module UnionFind = struct
   type t = int array
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/daemon/driver/driverInterface.ml ./src/daemon/driver/driverInterface.ml
--- ./src/daemon/driver/driverInterface.ml	2006-08-12 22:36:14.000000000 +0200
+++ ./src/daemon/driver/driverInterface.ml	2006-09-19 19:03:10.000000000 +0200
@@ -246,6 +246,8 @@
     
 let send_update_file gui file_num update =
   let file = file_find file_num in
+  if user2_can_view_file gui.gui_conn.conn_user.ui_user_name (file_owner file) (file_group file) then
+  begin
   let impl = as_file_impl file in
   let file_info = if update then
       P.File_info (file_info file) 
@@ -256,6 +258,7 @@
         impl.impl_file_last_seen)
   in
   gui_send gui file_info
+  end
 
 let send_update_user gui user_num update =
   let user = user_find user_num in
@@ -428,7 +431,7 @@
                   (File_add_source_event (file,c))
                 :: gui.gui_events.gui_new_events
             ) sources
-      ) !!files;
+      ) (user2_filter_files !!files gui.gui_conn.conn_user.ui_user_name);
       
       List.iter (fun file ->
           addevent gui.gui_events.gui_files (file_num file) true;
@@ -458,6 +461,7 @@
             end
       );
       
+      if user2_can_view_uploads gui.gui_conn.conn_user.ui_user_name then
       shared_iter (fun s ->
           addevent gui.gui_events.gui_shared_files (shared_num s) true
       );
@@ -466,8 +470,11 @@
           gui.gui_events.gui_new_events <- ev :: gui.gui_events.gui_new_events
       ) console_messages;                
       
+      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
       gui_send gui (
         P.Options_info (simple_options "" downloads_ini));
+
+      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
       networks_iter_all (fun r ->
           List.iter (fun opfile ->
               let prefix = r.network_shortname ^ "-" in
@@ -475,6 +482,7 @@
               gui_send gui (P.Options_info args)) r.network_config_file);
 
 (* Options panels defined in downloads.ini *)
+      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
       List.iter (fun s ->
           let section = section_name s in
           List.iter (fun o ->
@@ -484,6 +492,7 @@
       ) (sections downloads_ini);
 
 (* Options panels defined in users.ini *)
+      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
       List.iter (fun s ->
           let section = section_name s in
           List.iter (fun o ->
@@ -493,6 +502,7 @@
       ) (sections users_ini);
 
 (* Options panels defined in each plugin *)
+      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
       networks_iter_all (fun r ->
           let prefix = r.network_shortname ^ "-" in
           List.iter (fun file ->
@@ -554,7 +564,7 @@
                     (File_add_source_event (file,c))
                     :: gui.gui_events.gui_new_events
                 ) (file_active_sources file)
-            ) !!files;
+            ) (user2_filter_files !!files gui.gui_conn.conn_user.ui_user_name);
             
           end
     
@@ -613,7 +623,7 @@
               ) list
           
           | P.SetOption (name, value) ->
-	      if user2_is_admin gui.gui_conn.conn_user.ui_user_name || !!enable_user_config then
+	      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
 		CommonInteractive.set_fully_qualified_options name value
 	      else
 	        begin
@@ -644,6 +654,7 @@
               end
           
           | P.EnableNetwork (num, bool) ->
+	      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
               let n = network_find_by_num num in
               if n.op_network_is_enabled () <> bool then
                 (try
@@ -720,7 +731,7 @@
           
           | P.Download_query (filenames, num, force) ->
               let r = find_result num in
-              let files = result_download r filenames force in
+              let files = result_download r filenames force gui.gui_conn.conn_user.ui_user_name in
               List.iter CommonInteractive.start_download files
           
           | P.ConnectMore_query ->
@@ -731,7 +742,7 @@
                 if not (networks_iter_until_true
                     (fun n ->
                        try
-                         let s,r = network_parse_url n url in r
+                         let s,r = network_parse_url n url gui.gui_conn.conn_user.ui_user_name in r
                        with e ->
                          lprintf "Exception %s for network %s\n"
                            (Printexc2.to_string e) (n.network_name);
@@ -765,11 +776,13 @@
                 query_networks url
           
           | P.GetUploaders ->
+              if user2_can_view_uploads gui.gui_conn.conn_user.ui_user_name then
               gui_send gui (P.Uploaders
                   (List2.tail_map (fun c -> client_num c) 
                   (Intmap.to_list !uploaders)))
           
           | P.GetPending ->
+              if user2_can_view_uploads gui.gui_conn.conn_user.ui_user_name then
               gui_send gui (P.Pending (
                   List2.tail_map (fun c -> client_num c)
                   (Intmap.to_list !CommonUploads.pending_slots_map)))
@@ -778,13 +791,13 @@
               server_remove (server_find num)
           
           | P.SaveOptions_query list ->
-              
+	      if user2_is_admin gui.gui_conn.conn_user.ui_user_name then
               List.iter (fun (name, value) ->
                   CommonInteractive.set_fully_qualified_options name value) list;
               DriverInteractive.save_config ()
           
           | P.RemoveDownload_query num ->
-              file_cancel (file_find num)
+              file_cancel (file_find num) gui.gui_conn.conn_user.ui_user_name
           
           | P.ViewUsers num -> 
               let s = server_find num in
@@ -868,6 +881,7 @@
               client_connect c
           
           | P.DisconnectClient num ->
+              if user2_can_view_uploads gui.gui_conn.conn_user.ui_user_name then
               let c = client_find num in
               client_disconnect c
           
@@ -905,9 +919,9 @@
           | P.SwitchDownload (num, resume) ->
               let file = file_find num in
               if resume then
-                file_resume file          
+                file_resume file gui.gui_conn.conn_user.ui_user_name
               else
-                file_pause file
+                file_pause file gui.gui_conn.conn_user.ui_user_name
           
           | P.FindFriend user -> 
               networks_iter (fun n ->
@@ -1026,7 +1040,7 @@
   
           | NetworkMessage (num, s) ->
               let n = network_find_by_num num in
-              n.op_network_gui_message s
+              n.op_network_gui_message s gui.gui_conn.conn_user.ui_user_name
                 
           | AddServer_query (num, ip, port) ->
               let n = network_find_by_num num in
@@ -1036,7 +1050,7 @@
               let s = n.op_network_add_server (Ip.addr_of_ip ip) port in
               server_connect s
           | RefreshUploadStats ->
-              
+              if user2_can_view_uploads gui.gui_conn.conn_user.ui_user_name then
               shared_iter (fun s ->
                   update_shared_info s;
               ) 
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/daemon/driver/driverMain.ml ./src/daemon/driver/driverMain.ml
--- ./src/daemon/driver/driverMain.ml	2006-09-05 16:15:19.000000000 +0200
+++ ./src/daemon/driver/driverMain.ml	2006-09-19 19:03:10.000000000 +0200
@@ -218,7 +218,6 @@
   (try
       Options.load downloads_ini;
       Options.load users_ini;
-      ignore (DriverInteractive.verify_user_admin ());
       DriverInteractive.hdd_check ()
     with e ->
         lprintf_nl "Exception %s during options load" (Printexc2.to_string e);
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/bittorrent/bTComplexOptions.ml ./src/networks/bittorrent/bTComplexOptions.ml
--- ./src/networks/bittorrent/bTComplexOptions.ml	2006-09-16 11:47:17.000000000 +0200
+++ ./src/networks/bittorrent/bTComplexOptions.ml	2006-09-19 19:03:10.000000000 +0200
@@ -183,8 +183,9 @@
             (Printf.sprintf "BT-%s" (Sha1.to_string file_id)) in
         file_temp
   in
-  let file = new_file file_id torrent torrent_diskname file_temp file_state in
-
+  let file = new_file file_id torrent torrent_diskname
+	       file_temp file_state CommonUserDb.admin_user in
+    
   let file_uploaded = try
       value_to_int64 (List.assoc "file_uploaded" assocs)
     with _ -> zero
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/bittorrent/bTGlobals.ml ./src/networks/bittorrent/bTGlobals.ml
--- ./src/networks/bittorrent/bTGlobals.ml	2006-09-16 11:47:17.000000000 +0200
+++ ./src/networks/bittorrent/bTGlobals.ml	2006-09-19 19:03:10.000000000 +0200
@@ -223,7 +223,7 @@
 	  file.file_trackers <-  t :: file.file_trackers;
 	set_trackers file q
 
-let new_file file_id t torrent_diskname file_temp file_state =
+let new_file file_id t torrent_diskname file_temp file_state user =
   try
     Hashtbl.find files_by_uid file_id
   with Not_found ->
@@ -252,6 +252,8 @@
           file_shared = None;
         } and file_impl =  {
           dummy_file_impl with
+          impl_file_owner = user;
+          impl_file_group = CommonUserDb.user2_user_default_group user;
           impl_file_fd = Some file_fd;
           impl_file_size = t.torrent_length;
           impl_file_downloaded = Int64.zero;
@@ -299,15 +301,15 @@
 (*      lprintf "ADD FILE TO DOWNLOAD LIST\n"; *)
       file
 
-let new_download file_id t torrent_diskname =
+let new_download file_id t torrent_diskname user =
   let file_temp = Filename.concat !!DO.temp_directory
       (Printf.sprintf "BT-%s" (Sha1.to_string file_id)) in
-  new_file file_id t torrent_diskname file_temp FileDownloading
+  new_file file_id t torrent_diskname file_temp FileDownloading user
 
 let ft_by_num = Hashtbl.create 13
 let ft_counter = ref 0
 
-let new_ft file_name =
+let new_ft file_name user =
   incr ft_counter;
   let rec ft = {
       ft_file = file_impl;
@@ -316,6 +318,8 @@
       ft_retry = (fun _ -> ());
     } and file_impl =  {
       dummy_file_impl with
+      impl_file_owner = user;
+      impl_file_group = CommonUserDb.user2_user_default_group user;
       impl_file_fd = None;
       impl_file_size = zero;
       impl_file_downloaded = Int64.zero;
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/bittorrent/bTInteractive.ml ./src/networks/bittorrent/bTInteractive.ml
--- ./src/networks/bittorrent/bTInteractive.ml	2006-09-16 11:47:17.000000000 +0200
+++ ./src/networks/bittorrent/bTInteractive.ml	2006-09-19 19:03:10.000000000 +0200
@@ -469,7 +469,7 @@
 
 
 
-let load_torrent_string s =
+let load_torrent_string s user =
   let file_id, torrent = BTTorrent.decode_torrent s in
 
   (* Save the torrent, because we later want to put
@@ -495,13 +495,13 @@
   if !verbose then
     lprintf_nl "Starting torrent download with diskname: %s"
         torrent_diskname;
-  let file = new_download file_id torrent torrent_diskname in
+  let file = new_download file_id torrent torrent_diskname user in
   BTClients.get_sources_from_tracker file;
   BTShare.must_share_file file;
   CommonInteractive.start_download (file_find (file_num file));
   file
 
-let load_torrent_file filename =
+let load_torrent_file filename user =
   if !verbose then
     lprintf_nl "load_torrent_file %s" filename;
   let s = File.to_string filename in
@@ -510,7 +510,7 @@
   if Sys.file_exists filename
       && (Filename.dirname filename) = downloads_directory then
     Sys.remove filename;
-  ignore (load_torrent_string s)
+  ignore (load_torrent_string s user)
 
 let parse_tracker_reply file t filename =
 (*This is the function which will be called by the http client
@@ -576,7 +576,7 @@
     in
 
     let file = new_file file_id torrent torrent_diskname
-        filename FileShared in
+        filename FileShared CommonUserDb.admin_user in
     BTShare.must_share_file file;
     if !verbose_share then lprintf_file_nl file "Sharing file %s" filename;
     BTClients.connect_trackers file "started"
@@ -636,7 +636,8 @@
     let file_basename = Filename.basename file in
     if not (Unix2.is_directory file) then
     try
-      load_torrent_file file;
+      let user = fst (Unix32.owner file) in
+      load_torrent_file file (if not (CommonUserDb.user2_user_exist user) then CommonUserDb.admin_user else user);
       (try Sys.remove file with _ -> ())
     with 
       Torrent_can_not_be_used ->
@@ -651,12 +652,12 @@
           lprintf_nl "ft_retry: exception %s" (Printexc2.to_string e)
   ) ft_by_num
 
-let load_torrent_from_web r ft =
+let load_torrent_from_web r user ft =
   let module H = Http_client in
   H.wget r (fun filename ->
       if ft_state ft = FileDownloading then begin
-          load_torrent_file filename;
-          file_cancel (as_ft ft)
+          load_torrent_file filename user;
+          file_cancel (as_ft ft) CommonUserDb.admin_user
         end)
 
 let valid_torrent_extension url =
@@ -669,7 +670,7 @@
   let b = Str.group_end 1 in
   String.sub text a (b - a)
 
-let op_network_parse_url url =
+let op_network_parse_url url user =
   let location_regexp = "Location: \\(.*\\)" in
   try
     let real_url = get_regexp_string url (Str.regexp location_regexp) in
@@ -700,13 +701,13 @@
                   ) "" cookies
                 ) ]
             with Not_found -> []);
-            H.req_max_retry = 10;
+	  H.req_max_retry = 10;
           } in
 
         let file_diskname = Filename.basename u.Url.short_file in
-        let ft = new_ft file_diskname in
-        ft.ft_retry <- load_torrent_from_web r ;
-        load_torrent_from_web r ft;
+        let ft = new_ft file_diskname user in
+        ft.ft_retry <- (load_torrent_from_web r user);
+        load_torrent_from_web r user ft;
         "started download", true
       )
     else
@@ -717,7 +718,7 @@
         try
           if !verbose then lprintf_nl "Not_found and trying to load %s" url;
           try
-            load_torrent_file url;
+            load_torrent_file url user;
             "", true
           with
 	    Already_exists -> "A torrent with this name is already in the download queue", false
@@ -950,13 +951,13 @@
       let buf = o.conn_buf in
       if Sys.file_exists url then
         begin
-          load_torrent_file url;
+	  load_torrent_file url o.conn_user.ui_user_name;
           Printf.bprintf buf "loaded file %s\n" url
 	end
       else
         begin
           let url = "Location: " ^ url ^ "\nContent-Type: application/x-bittorrent" in
-          let result = fst (op_network_parse_url url) in
+	  let result = fst (op_network_parse_url url o.conn_user.ui_user_name) in
           Printf.bprintf buf "%s\n" result
 	end;
       _s ""
@@ -1031,12 +1032,12 @@
 open LittleEndian
 open GuiDecoding
 
-let op_gui_message s =
+let op_gui_message s user =
   match get_int16 s 0 with
     0 ->
       let text = String.sub s 2 (String.length s - 2) in
       if !verbose then lprintf_nl "received torrent from gui...";
-      ignore (load_torrent_string text)
+      ignore (load_torrent_string text user)
   | 1 -> (* 34+ *)
       let n = get_int s 2 in
       let a, pos = get_string s 6 in
@@ -1072,7 +1073,7 @@
   network.op_network_forget_search <- (fun s -> ());
   network.op_network_connect_servers <- (fun s -> ());
   network.op_network_search <- (fun ss buf -> ());
-  network.op_network_download <- (fun r -> dummy_file);
+  network.op_network_download <- (fun r user -> dummy_file);
   network.op_network_recover_temp <- (fun s -> ());
   let clean_exit_started = ref false in
   network.op_network_clean_exit <- (fun s ->
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/donkey/donkeyComplexOptions.ml ./src/networks/donkey/donkeyComplexOptions.ml
--- ./src/networks/donkey/donkeyComplexOptions.ml	2006-09-05 16:15:19.000000000 +0200
+++ ./src/networks/donkey/donkeyComplexOptions.ml	2006-09-19 19:03:10.000000000 +0200
@@ -273,7 +273,7 @@
   in
 
   let file = DonkeyGlobals.new_file file_diskname file_state
-    (Md4.of_string file_md4) file_size "" true in
+    (Md4.of_string file_md4) file_size "" true CommonUserDb.admin_user in
 
   (try
       set_file_best_name (as_file file)
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/donkey/donkeyGlobals.ml ./src/networks/donkey/donkeyGlobals.ml
--- ./src/networks/donkey/donkeyGlobals.ml	2006-09-16 17:36:59.000000000 +0200
+++ ./src/networks/donkey/donkeyGlobals.ml	2006-09-19 19:03:10.000000000 +0200
@@ -311,7 +311,7 @@
           set_file_best_name file best_name "" 0
     with Not_found -> ()
 
-let new_file file_diskname file_state md4 file_size filename writable =
+let new_file file_diskname file_state md4 file_size filename writable user =
 
   try
       let file = find_file md4 in
@@ -402,6 +402,8 @@
         }
       and file_impl = {
           dummy_file_impl with
+          impl_file_owner = user;
+          impl_file_group = CommonUserDb.user2_user_default_group user;
           impl_file_val = file;
           impl_file_ops = file_ops;
           impl_file_age = last_time ();
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/donkey/donkeyInteractive.ml ./src/networks/donkey/donkeyInteractive.ml
--- ./src/networks/donkey/donkeyInteractive.ml	2006-09-05 16:18:24.000000000 +0200
+++ ./src/networks/donkey/donkeyInteractive.ml	2006-09-19 19:03:10.000000000 +0200
@@ -181,14 +181,11 @@
     )
 
 let already_done = Failure (Printf.sprintf (_b "File already downloaded (use 'force_download' if necessary)"))
-
 let no_download_to_force = Failure (Printf.sprintf (_b "No forceable download found"))
+exception Already_downloading of string
+exception Already_shared of string
 
-let already_downloading = Failure (Printf.sprintf (_b "File is already in download queue"))
-
-let already_shared = Failure (Printf.sprintf (_b "File is already shared"))
-
-let really_query_download filename size md4 location old_file absents =
+let really_query_download filename size md4 location old_file absents user =
 
   begin
     try
@@ -226,7 +223,7 @@
   end;
 
 (* TODO RESULT  let other_names = DonkeyIndexer.find_names md4 in *)
-  let file = new_file file_diskname FileDownloading md4 size filename true in
+  let file = new_file file_diskname FileDownloading md4 size filename true user in
   begin
     match absents with
       None -> ()
@@ -295,7 +292,7 @@
   );
   as_file file
 
-let query_download filename size md4 location old_file absents force =
+let query_download filename size md4 location old_file absents force user =
   if force then
     if !forceable_download = [] then
       raise no_download_to_force
@@ -303,20 +300,23 @@
       begin
         let f = List.hd !forceable_download in
 	  forceable_download := [];
-	  really_query_download (List.hd f.result_names) f.result_size md4 None None None
+	  really_query_download (List.hd f.result_names) f.result_size md4 None None None user
       end
   else
     begin
       try
         let file = find_file md4 in
 	  if (file_state file) = FileShared then
-	    raise already_shared
+	    raise (Already_shared (Printf.sprintf (_b "File is already shared%s")
+	      (match file.file_shared with
+		 None -> ""
+	       | Some sh -> (" in " ^ (Filename2.dirname sh.impl_shared_fullname)))))
 	  else
 	    begin
 (* jave TODO: if a user currently not downloading this file is requesting the download add this user
    to the list of users currently downloading this file *)
 	      forceable_download := [];
-	      raise already_downloading 
+	      raise (Already_downloading (Printf.sprintf (_b "File is already in download queue of %s") (file_owner (as_file file))))
 	    end
       with Not_found ->
         begin
@@ -336,19 +336,19 @@
         else
           begin
             forceable_download := [];
-            really_query_download filename size md4 location old_file absents
+            really_query_download filename size md4 location old_file absents user
           end
         end
     end
 
-let result_download r filenames force =
+let result_download r filenames force user =
   let rec iter uids =
     match uids with
       [] -> raise IgnoreNetwork
     | uid :: tail ->
         match Uid.to_uid uid with
           Ed2k md4 ->
-            query_download (List.hd filenames) r.result_size md4 None None None force
+            query_download (List.hd filenames) r.result_size md4 None None None force user
         | _  -> iter tail
   in
   iter r.result_uids
@@ -391,7 +391,7 @@
 		(match !filename_met with
 		   None -> filename
 		| Some s -> s) !size f.P.md4 None
-              (Some filename) (Some (List.rev f.P.absents)));
+              (Some filename) (Some (List.rev f.P.absents)) CommonUserDb.admin_user);
       with _ -> ()
   ) list
 
@@ -508,7 +508,7 @@
 
 
 
-let parse_donkey_url url =
+let parse_donkey_url url user =
   let url = Str.global_replace (Str.regexp "|sources,") "|sources|" url in
   match String2.split url '|' with
 (* TODO RESULT *)
@@ -536,7 +536,7 @@
           begin
 	    try
               let file = query_download name (Int64.of_string size)
-                (Md4.of_string md4) None None None false in
+                (Md4.of_string md4) None None None false user in
 	      let new_file = find_file (Md4.of_string md4) in
 	      CommonInteractive.start_download file;
 	      if !new_sources <> [] then
@@ -547,7 +547,10 @@
     	          (Printf.sprintf (_b "added %d sources to new download") (List.length !new_sources)), true
     	        end
     	      else "", true
-    	    with e -> (Printexc2.to_string e), false
+    	    with
+	      Already_downloading (s)
+	    | Already_shared (s) -> s, false
+	    | e -> (Printexc2.to_string e), false
     	  end
     	end
   | "ed2k://" :: "file" :: name :: size :: md4 :: _
@@ -566,12 +569,14 @@
 	in
           begin try
             let file = query_download name (Int64.of_string size)
-              (Md4.of_string md4) None None None false;
+              (Md4.of_string md4) None None None false user;
             in
             CommonInteractive.start_download file;
             "", true
-          with e ->
-            (Printexc2.to_string e), false
+          with
+	    Already_downloading (s)
+	  | Already_shared (s) -> s, false
+	  | e -> (Printexc2.to_string e), false
           end
   | "ed2k://" :: "server" :: ip :: port :: _
   | "server" :: ip :: port :: _ ->
@@ -776,6 +781,7 @@
     "<port> :\t\t\t\tchange connection port";
 
     "scan_temp", Arg_none (fun o ->
+	if CommonUserDb.user2_is_admin o.conn_user.ui_user_name then begin
         let buf = o.conn_buf in
         let list = Unix2.list_directory !!temp_directory in
 
@@ -873,24 +879,22 @@
         ) list;
 
         if use_html_mods o then Printf.bprintf buf "\\</table\\>\\</div\\>";
+        "" end
+	else begin
+	  CommonUserDb.print_command_result o o.conn_buf "You are not allowed to use scan_temp";
+	"" end
 
-        ""
     ), ":\t\t\t\tprint temp directory content";
 
     "sources", Arg_none (fun o ->
-        let buf = o.conn_buf in
-        DonkeySources.print buf o.conn_output;
-        ""
+	if CommonUserDb.user2_is_admin o.conn_user.ui_user_name then begin
+          DonkeySources.print o.conn_buf o.conn_output;
+          "" end
+	else begin
+	  CommonUserDb.print_command_result o o.conn_buf "You are not allowed to list sources";
+	  "" end
     ), ":\t\t\t\tshow sources currently known";
 
-    (*
-    "update_sources", Arg_none (fun o ->
-        let buf = o.conn_buf in
-        DonkeySources.recompute_ready_sources ();
-        "done"
-    ), ":\t\t\trecompute order of connections to sources (experimental)";
-*)
-
     "xs", Arg_none (fun o ->
         let buf = o.conn_buf in
         if !xs_last_search >= 0 then begin
@@ -920,7 +924,7 @@
 (* TODO RESULT *)
     "dd", Arg_two(fun size md4 o ->
         let file = query_download md4 (Int64.of_string size)
-          (Md4.of_string md4) None None None false in
+          (Md4.of_string md4) None None None false o.conn_user.ui_user_name in
         CommonInteractive.start_download file;
         "download started"
     ), "<size> <md4> :\t\t\tdownload from size and md4";
@@ -1003,8 +1007,8 @@
       with
         Not_found -> ()
   );
-  network.op_network_download <- (fun r ->
-      result_download r r.result_names r.result_force
+  network.op_network_download <- (fun r user ->
+      result_download r r.result_names r.result_force user
   )
 
 module P = GuiTypes
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/donkey/donkeyOneFile.ml ./src/networks/donkey/donkeyOneFile.ml
--- ./src/networks/donkey/donkeyOneFile.ml	2006-08-09 01:55:28.000000000 +0200
+++ ./src/networks/donkey/donkeyOneFile.ml	2006-09-19 19:03:10.000000000 +0200
@@ -435,7 +435,7 @@
 			      (file_best_name file) (Printexc2.to_string e) in
                     Printf2.lprint_string m;
                     CommonEvent.add_event (Console_message_event m);
-                    file_pause (as_file file);
+                    file_pause (as_file file) CommonUserDb.admin_user;
                     raise e
                   end
           
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/donkey/donkeyShare.ml ./src/networks/donkey/donkeyShare.ml
--- ./src/networks/donkey/donkeyShare.ml	2006-09-01 18:22:15.000000000 +0200
+++ ./src/networks/donkey/donkeyShare.ml	2006-09-19 19:03:10.000000000 +0200
@@ -99,7 +99,7 @@
       lprintf_nl "Sharing file with MD4: %s" (Md4.to_string md4);
 
     let file = new_file sh.sh_name FileShared md4 sh.sh_size
-        "" false in
+        "" false CommonUserDb.admin_user in
     must_share_file file codedname old_impl;
     file.file_computed_md4s <- md4s;
     add_file_filenames (as_file file) (Filename.basename sh.sh_name);
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fasttrack/fasttrackGlobals.ml ./src/networks/fasttrack/fasttrackGlobals.ml
--- ./src/networks/fasttrack/fasttrackGlobals.ml	2006-09-01 18:22:15.000000000 +0200
+++ ./src/networks/fasttrack/fasttrackGlobals.ml	2006-09-19 19:03:10.000000000 +0200
@@ -267,7 +267,7 @@
 
 let min_range_size = megabyte
 
-let new_file file_temporary file_name file_size file_hash =
+let new_file file_temporary file_name file_size file_hash user =
   let file_temp = Filename.concat !!temp_directory file_temporary in
 (*      (Printf.sprintf "FT-%s" (Md4.to_string file_id)) in *)
   let t = Unix32.create_rw file_temp in
@@ -293,6 +293,8 @@
       impl_file_fd = Some t;
       impl_file_size = file_size;
       impl_file_downloaded = Int64.zero;
+      impl_file_owner = user;
+      impl_file_group = CommonUserDb.user2_user_default_group user;
       impl_file_val = file;
       impl_file_ops = file_ops;
       impl_file_age = last_time ();
@@ -335,7 +337,7 @@
 
 exception FileFound of file
 
-let new_file file_id file_name file_size file_uids =
+let new_file file_id file_name file_size file_uids user =
   let file = ref None in
   List.iter (fun uid ->
       match Uid.to_uid uid with
@@ -343,7 +345,7 @@
           file := Some (try
               Hashtbl.find files_by_uid file_hash
             with _ ->
-                let file = new_file file_id file_name file_size file_hash in
+                let file = new_file file_id file_name file_size file_hash user in
                 Hashtbl.add files_by_uid file_hash file;
                 file)
       | _ -> ()
